//-----------------------------------------
// LScript Modeler template
//
// MGSharpSmooth
// Written by Mike Green 
// Dodgy@shortbutpurple.fsnet.co.uk
//  7/10/03

@version 2.2
@warnings
@script modeler
//@name Sharp Smooth
//version 1.3 
//rewrote the core code to be more robust in most situations

//version 1.1 
// fixes problem if you have both points and polys selected. 

// global values go here

main
{

    myversion=1.3;
    mypointpos;
    selmode(USER);
    myuserpointno=pointcount();
    selpolygon(CLEAR,FACE);
    selpolygon(CLEAR,BONE);
    selpolygon(CLEAR,MBALL);
    allpolys=polycount();
    myuserpolyno=allpolys[1];

    selmode(DIRECT);
    mypointno=pointcount();
    allpolys=polycount();
    mypolyno=allpolys[1];

    
    if (mypointno==0 and allpolys[1]<2)
        error ("Please select one or more points or 2 or more curves");
    if (mypointno==myuserpointno and mypolyno==mypolyuserno)
        error ("Please deselect some points or curves");

    if (mypointno==myuserpointno)
    { 
        editbegin();
        mypoints=points;
        i=1;
        while (i<=mypoints.size())
        {

            mypoint=mypoints[i];
            mypolys=mypoint.polygon();
            j=1;
            while(j<=mypolys.size())
            {
                mypolys=mypoint.polygon();
                mypoly=mypolys[j];
                if(mypoly && mypoly.isCurve() && mypoly.pointCount>=2 && 
                    mypoly.points[1]!=mypoint && mypoly.points[mypoly.pointCount]!=mypoint)
                {
                    if(mypoly.points[2]==mypoint && mypoly.hasCCStart() &&
                        mypoly.points[mypoly.pointCount - 1]==mypoint && mypoly.hasCCEnd())
                    {
                        makecurvesmoothloop(mypoly,mypoint);
                    }
                    else if(mypoly.points[2]==mypoint && mypoly.hasCCStart())
                    {
                        makecurveS(mypoly,mypoint);
                    }
                    else if(mypoly.points[mypoly.pointCount - 1]==mypoint && mypoly.hasCCEnd())
                    {
                        makecurveE(mypoly,mypoint);
                    }
                    else
                    {
                       splitpoly(mypoly,mypoint);
                    }
                    j=0;
                    rempoly(mypoly);
                    editend();
                    editbegin();
                }
                j++;
            }
            i++;
        }

        editend();

    }

//-------------------------------------------------------------------------------------    
// smoothing of two polys:
    else
    {
        selmode(USER);
        smoothcurves();
        if (mypolyno==myuserpolyno)
            selpolygon(CLEAR);
    }
}

makecurvesmoothloop: mypoly,mypoint
{
                        for(p=2;p<=mypoly.pointCount - 1 ;p++)
                        {
                            mynew[p - 1]=mypoly.points[p];
                        }
                        addcurve(mynew,mypoly.surface);
}

makecurveS: mypoly,mypoint
{
                        for(p=2;p<=mypoly.pointCount;p++)
                        {
                            mynew[p - 1]=mypoly.points[p];
                        }
                        if(mypoly.hasCCEnd())
                            addcurve(mynew,mypoly.surface,END);
                        else
                            addcurve(mynew,mypoly.surface);
}

makecurveE: mypoly,mypoint
{
                        for(p=1;p<=mypoly.pointCount - 1;p++)
                        {
                            mynew[p]=mypoly.points[p];
                        }
                        if(mypoly.hasCCStart())
                            addcurve(mynew,mypoly.surface,START);
                        else
                            addcurve(mynew,mypoly.surface);
}

splitpoly: mypoly,mypoint
{
                        p=1;
                        while(mypoly.points[p]!=mypoint)
                        {
                            mynew[p]=mypoly.points[p];
                            p++;
                        }

                        mynew[p]=mypoly.points[p];
                        if(mypoly.hasCCStart())
                            addcurve(mynew,mypoly.surface,START);
                        else
                            addcurve(mynew,mypoly.surface);

                        mynew=nil;
                        q=1;
                        while(p<=mypoly.pointCount)
                        {
                            mynew[q]=mypoly.points[p];
                            q++;
                            p++;
                        }
                        if(mypoly.hasCCEnd())
                            addcurve(mynew,mypoly.surface,END);
                        else
                            addcurve(mynew,mypoly.surface);
}                        









